<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for TextMessageInboxSelection_V2 StructType
 * @subpackage Structs
 */
class TextMessageInboxSelection_V2 extends AbstractStructBase
{
    /**
     * The Read
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * - nillable: true
     * @var bool
     */
    public $Read;
    /**
     * The Treated
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * - nillable: true
     * @var bool
     */
    public $Treated;
    /**
     * The DateTimeRange
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\DateTimeRangeSelection
     */
    public $DateTimeRange;
    /**
     * The SelectionFromToday
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\DateTimeAndIdSelection
     */
    public $SelectionFromToday;
    /**
     * The TextMessages
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \ArrayType\ArrayOfLong
     */
    public $TextMessages;
    /**
     * The Vehicles
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \ArrayType\ArrayOfIdentifierVehicle
     */
    public $Vehicles;
    /**
     * Constructor method for TextMessageInboxSelection_V2
     * @uses TextMessageInboxSelection_V2::setRead()
     * @uses TextMessageInboxSelection_V2::setTreated()
     * @uses TextMessageInboxSelection_V2::setDateTimeRange()
     * @uses TextMessageInboxSelection_V2::setSelectionFromToday()
     * @uses TextMessageInboxSelection_V2::setTextMessages()
     * @uses TextMessageInboxSelection_V2::setVehicles()
     * @param bool $read
     * @param bool $treated
     * @param \StructType\DateTimeRangeSelection $dateTimeRange
     * @param \StructType\DateTimeAndIdSelection $selectionFromToday
     * @param \ArrayType\ArrayOfLong $textMessages
     * @param \ArrayType\ArrayOfIdentifierVehicle $vehicles
     */
    public function __construct($read = null, $treated = null, \StructType\DateTimeRangeSelection $dateTimeRange = null, \StructType\DateTimeAndIdSelection $selectionFromToday = null, \ArrayType\ArrayOfLong $textMessages = null, \ArrayType\ArrayOfIdentifierVehicle $vehicles = null)
    {
        $this
            ->setRead($read)
            ->setTreated($treated)
            ->setDateTimeRange($dateTimeRange)
            ->setSelectionFromToday($selectionFromToday)
            ->setTextMessages($textMessages)
            ->setVehicles($vehicles);
    }
    /**
     * Get Read value
     * @return bool
     */
    public function getRead()
    {
        return $this->Read;
    }
    /**
     * Set Read value
     * @param bool $read
     * @return \StructType\TextMessageInboxSelection_V2
     */
    public function setRead($read = null)
    {
        // validation for constraint: boolean
        if (!is_null($read) && !is_bool($read)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a bool, %s given', var_export($read, true), gettype($read)), __LINE__);
        }
        $this->Read = $read;
        return $this;
    }
    /**
     * Get Treated value
     * @return bool
     */
    public function getTreated()
    {
        return $this->Treated;
    }
    /**
     * Set Treated value
     * @param bool $treated
     * @return \StructType\TextMessageInboxSelection_V2
     */
    public function setTreated($treated = null)
    {
        // validation for constraint: boolean
        if (!is_null($treated) && !is_bool($treated)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a bool, %s given', var_export($treated, true), gettype($treated)), __LINE__);
        }
        $this->Treated = $treated;
        return $this;
    }
    /**
     * Get DateTimeRange value
     * @return \StructType\DateTimeRangeSelection|null
     */
    public function getDateTimeRange()
    {
        return $this->DateTimeRange;
    }
    /**
     * Set DateTimeRange value
     * @param \StructType\DateTimeRangeSelection $dateTimeRange
     * @return \StructType\TextMessageInboxSelection_V2
     */
    public function setDateTimeRange(\StructType\DateTimeRangeSelection $dateTimeRange = null)
    {
        $this->DateTimeRange = $dateTimeRange;
        return $this;
    }
    /**
     * Get SelectionFromToday value
     * @return \StructType\DateTimeAndIdSelection|null
     */
    public function getSelectionFromToday()
    {
        return $this->SelectionFromToday;
    }
    /**
     * Set SelectionFromToday value
     * @param \StructType\DateTimeAndIdSelection $selectionFromToday
     * @return \StructType\TextMessageInboxSelection_V2
     */
    public function setSelectionFromToday(\StructType\DateTimeAndIdSelection $selectionFromToday = null)
    {
        $this->SelectionFromToday = $selectionFromToday;
        return $this;
    }
    /**
     * Get TextMessages value
     * @return \ArrayType\ArrayOfLong|null
     */
    public function getTextMessages()
    {
        return $this->TextMessages;
    }
    /**
     * Set TextMessages value
     * @param \ArrayType\ArrayOfLong $textMessages
     * @return \StructType\TextMessageInboxSelection_V2
     */
    public function setTextMessages(\ArrayType\ArrayOfLong $textMessages = null)
    {
        $this->TextMessages = $textMessages;
        return $this;
    }
    /**
     * Get Vehicles value
     * @return \ArrayType\ArrayOfIdentifierVehicle|null
     */
    public function getVehicles()
    {
        return $this->Vehicles;
    }
    /**
     * Set Vehicles value
     * @param \ArrayType\ArrayOfIdentifierVehicle $vehicles
     * @return \StructType\TextMessageInboxSelection_V2
     */
    public function setVehicles(\ArrayType\ArrayOfIdentifierVehicle $vehicles = null)
    {
        $this->Vehicles = $vehicles;
        return $this;
    }
}
